#ifndef OVERLAY_RENDERER_H
#define OVERLAY_RENDERER_H
/*
OverlayRenderer class
*/
#include <SupportDefs.h>
#include <MediaDefs.h>
#include <Bitmap.h>
#include <GraphicsDefs.h>
#include "VideoRenderer.h"

class OverlayRenderer : public VideoRenderer
{
public:
		OverlayRenderer();
	virtual	~OverlayRenderer();
	status_t	InitCheck() {return B_OK;};
	const char	*RendererName() const {return "overlay";};
	const char	*ColorSpaceName() const;
	color_space	ColorSpace();
	void		*Bits();
	status_t	LockBits();
	status_t	UnlockBits();
	
	// render the frame in buff, the next buffer to write to is returned (can be the same)
	// should block until the buffer returned is ready to be fulled
	void		*Draw(void *buff);
	
	status_t	Install(MediaView *view, media_format *format);
	status_t	Use();
	status_t	Dispose();
	color_space	NextColorSpace(int *cookie); // cookie = 0 first
	BRect		Bounds();
	int32		BytesPerRow();
private:

//	colorspace	cspace;
	int			cs_index; // index in colspace[]
	BBitmap		*bitmap;
	BRect		*bitmapBounds;
	MediaView	*view;
};


#endif // OVERLAY_RENDERER_H
